/*
 * openantivirus.c - Functions for communicating with OpenAntiVirus.org's
 *                   ScannerDaemon.
 *
 * Copyright (C) 2001  ViaLink Internet S/C Ltda, Rio de Janeiro, Brazil
 *                     http://www.vialink.com.br/
 * Author:             Juan Carlos Castro y Castro <jcastro@vialink.com.br>
 *
 * See the README file for more info.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can either send email to this
 * program's maintainer or write to: The Free Software Foundation,
 * Inc.; 59 Temple Place, Suite 330; Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <netdb.h>
#include <netinet/in.h>

#include "openantivirus.h"

FILE *contactdaemon(unsigned short port)
{
	int			sock;
	struct sockaddr_in	daemonaddr;

	sock = socket(PF_INET, SOCK_STREAM, getprotobyname("tcp")->p_proto);
	if (sock == -1)
		return NULL;

	memset(&daemonaddr, 0, sizeof(daemonaddr));
	daemonaddr.sin_family = AF_INET;
	daemonaddr.sin_addr.s_addr = htonl(0x7F000001);
	daemonaddr.sin_port = htons(port);

	if (connect(sock, (struct sockaddr *) &daemonaddr, sizeof(daemonaddr)))
	{
		close(sock);
		return NULL;
	}

	return fdopen(sock, "r+");
}
